/**
 * BasicOperatorType.java
 *
 * File generated from the XValidator4::BasicOperatorType uml Enumeration
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.model;

import javax.persistence.*;
import javax.xml.bind.annotation.*;
import java.util.Date;

/**
 * Description of the enumeration BasicOperatorType.
 *
 */

@XmlRootElement(name = "DateFormatType")
@XmlAccessorType(XmlAccessType.FIELD)
@Entity
@Table(name = "xval_date_format_type", schema = "public")
@SequenceGenerator(name = "xval_date_format_type_sequence", sequenceName = "xval_date_format_type_id_seq", allocationSize = 1)
public class DateFormatType {

	@Id
	@Column(name = "id", nullable = false, unique = true)
	@GeneratedValue(generator = "xval_date_format_type_sequence", strategy = GenerationType.SEQUENCE)
	@XmlTransient
	private Integer id;

	@XmlAttribute
	@Column(name = "label", nullable = false, unique = true)
	private String label;

	@XmlAttribute(required = true)
	@Column(name = "value", nullable = false)
	private String value;

	@XmlTransient
	@Column(name = "precision", nullable = false)
	private int precision;

	public DateFormatType(){
	}

	public DateFormatType(String label, String value, int precision) {
		this.value = value;
		this.precision = precision;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public String getValue() {
		return value;
	}

	public void setValue(String value) {
		this.value = value;
	}

	public int getPrecision() {
		return precision;
	}

	public void setPrecision(int precision) {
		this.precision = precision;
	}

	public void setLabel(String label) {
		this.label = label;
	}

	public String getLabel() {
		return label;
	}

	@Override
	public String toString() {
		return label + " (" + value + ")";
	}

	@Override
	public boolean equals(final Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (this.getClass() != obj.getClass()) {
			return false;
		}
		final DateFormatType other = (DateFormatType) obj;
		if (this.label == null) {
			if (other.label != null) {
				return false;
			}
		} else if (!this.label.equals(other.label)) {
			return false;
		}
		return true;
	}
}